//*********************************************************************************
// heli.sqf
// this script permit to call a medevac chopper that will go to the MM_PLAYER,
// a corpsman dismount the chopper and willo go near the MM_PLAYER position
// to heal all soldiers at MM_PLAYER command
//*********************************************************************************

if (MM_AVVIONE == 1) then { //check if this script is already active
	
	MM_AVVIONE = 0;	
	publicVariable "MM_AVVIONE";
	
	terminate MM_LAND;
	
	deleteVehicle MM_HELIH2;
	
	MM_AVVIONE_2 = 0;
	MM_AZZIONE = 0;
	MM_OVVIO = 0;
	MM_PLAYER removeAction MM_ACTION0;
	MM_READY = 0;
	MM_CREATED = 0;
	
	if (!MM_CISIAMO) then{ //only if it was not created a base camp
		_rivai = [] execVM "unitCreation.sqf";
	};

	waitUntil{MM_WEARE == 1}; //wait for creation of the units
	
	if (MM_CISIAMO) then{
		_script = [] execVM "checkkin.sqf";  
		MM_CHOPPER engineOn true; 
	};
	
	// texts and sound trigger activation
	MM_ONE = 1;
	publicVariable "MM_ONE";
	sleep 10;
	MM_TWO = 1;
	publicVariable "MM_TWO";
	sleep 4;
	MM_THREE = 1;
	publicVariable "MM_THREE";

	_way_count = waypoints MM_BETA; //array that contain all the references about MM_BETA's waypoints
	{
		deleteWaypoint _x; 
	} forEach _way_count;
	
	
	//-------------------------------------- Create waypoints ----------------------------------------
	_wp1 = MM_BETA addWaypoint [position MM_PLAYER, 0]; //add a waypoint at the pilot which moves nearby the MM_PLAYER position
	_wp1 setWaypointType "MOVE";
	_wp1 setWaypointSpeed "FULL";

	if (MM_AZZIONE == 0) then{
		MM_DUMMYA = MM_PLAYER addAction ["",""];
		MM_AACTION = MM_PLAYER addAction ["Abort Medevac", "dummy3.sqf"];
		sleep 1;
		MM_PLAYER removeAction MM_DUMMYA;
	};
	
	waitUntil{MM_CHOPPER in ((getPos MM_PLAYER) nearObjects ["All", 1200])};
	
	// texts and sound trigger activation
	MM_FOUR = 1;
	publicVariable "MM_FOUR";
	
	sleep 3;
	
	MM_PLAYER addMagazine "SmokeShellRed";
	
	if(MM_COUNTER == 0) then{
		MM_EH1 = MM_PLAYER addEventHandler ["Fired", "if((_this select 4) == 'SmokeShellRed') then {MM_CREATED = 1; MM_PLAYER sideChat 'Smoke grenade out, over'; MM_COUNTER = 0; MM_PLAYER removeEventHandler ['Fired', MM_EH1]};"];
		MM_COUNTER = 1;
	};	
	
	//when the helo is nearby MM_PLAYER
	waitUntil{MM_CHOPPER in ((getPos MM_PLAYER) nearObjects ["All", 700])};
	doStop MM_CHOPPER;
	
	//------------------------------------- wait for smoke launch ---------------------------------
	waitUntil{MM_CREATED == 1};

	sleep 5;
	
	_smokea =(position MM_PLAYER) nearObjects ["SmokeShellRed", 250];
	
	MM_BETA setBehaviour "COMBAT";
	MM_MEDIC moveInCargo MM_CHOPPER;
	MM_GUNNR1 moveInCargo MM_CHOPPER;
	MM_GUNNR2 moveInCargo MM_CHOPPER;
	MM_CHOPPER doMove (position MM_PLAYER);

	
	MM_SMOKE = _smokea select 0;
	
	// texts and sound trigger activation
	MM_FIVE = 1;
	publicVariable "MM_FIVE";
	
	// remove the Abort medevac action
	MM_PLAYER removeAction MM_AACTION;  // on self-hosted server
	if(MM_REMOVE == 0) then{ 		    // on dedi server or client
		MM_REMOVE = 1;
	}	
	else{
		MM_REMOVE = 0;
	};
	publicVariable "MM_REMOVE";
	
	MM_AZZIONE = 0;
	//publicVariable "MM_AZZIONE";
	
	//create an empty H to make a precise landing at the smoke location
	MM_HELIH2 = createVehicle ["HeliHEmpty", position MM_SMOKE, [], 0, "NONE"]; 

	
	_wp2 = MM_BETA addWaypoint [position MM_SMOKE, 0];
	_wp2 setWaypointType "UNLOAD";
	_wp2 setWaypointBehaviour "CARELESS";
	_wp2 setWaypointSpeed "NORMAL";
	_wp2 setWaypointStatements ["true", "if (isServer) then {MM_LES = execVM 'ladder.sqf'}"]; 
	
	
	waitUntil{(getPosATL MM_MEDIC) select 2 <= 0.5 || (getPosATL MM_GUNNR1) select 2 <= 0.5 || (getPosATL MM_GUNNR2) select 2 <= 0.5 || (!(alive MM_MEDIC) && !(alive MM_GUNNR1) && (!alive MM_GUNNR2))};
	
	//MM_PILOT1 sideChat "Medevac support in position sir!";
	MM_EIGHTEEN = 1;
	publicVariable "MM_EIGHTEEN";
	
	//MM_DUMMYA = MM_PLAYER addAction ["", ""];
	MM_RTB = MM_PLAYER addAction ["Medevac RTB", "dummy7.sqf"];  // on dedi or self-hosted
	if (MM_ADDRTB == 1) then{									 // on SP or client
		MM_ADDRTB = 0;
	}
	else{
		MM_ADDRTB = 1;
	};
	publicVariable "MM_ADDRTB";
	
	MM_RTBOK = 1;	// in case of death tell the system to regive you the Medevac RTB action
	
	sleep 5;

	MM_MEDIC allowDammage true;
	MM_GUNNR1 allowDammage true;
	MM_GUNNR2 allowDammage true;

	//move the corpsman nearby the unit 'MM_PLAYER'
	MM_MEDIC setUnitPos "Middle";
	MM_MEDIC moveTo (position MM_PLAYER); 
	
	//only if the medic still alive can join the player's group
	if(alive MM_MEDIC) then{
		[MM_MEDIC] join (group MM_PLAYER);
	};
	
	[MM_GUNNR1, MM_GUNNR2] join MM_CHARLIE;
	[MM_PILOT1] join MM_ALPHA; //pilots join a dummy group to prevent the mh60s go into formation 

	MM_ALPHA setBehaviour "CARELESS";
	
	_wps1 = MM_CHARLIE addWaypoint [[((position MM_CHOPPER) select 0) + 20, (position MM_CHOPPER) select 1, (position MM_CHOPPER) select 2], 0]; //units guard the landing point of the mh60s
	_wps1 setWaypointType "MOVE";
	_wps1 setWaypointBehaviour "AWARE";
	_wps1 setWaypointCompletionRadius 20; 
	MM_GUNNR1 setUnitPos "Middle";
	MM_GUNNR2 setUnitPos "Middle";
	
	//wait orders from unit 'MM_PLAYER' to get in the medevac vehicle
	waitUntil{MM_READY == 1}; 
	
	terminate MM_LAND;
	
	deleteGroup MM_BETA;
	
	onMapSingleClick "";
	terminate MM_REINSERTING;
	deleteMarker "MM_MKR3";
	
	if(side MM_PLAYER == west) then{
		MM_BETA = createGroup west;
	}
	else{
		if(side MM_PLAYER == east) then{
			MM_BETA = createGroup east;
		}	
		else{
			if(side MM_PLAYER == resistance) then{
				MM_BETA = creategroup resistance;
			}
			else{
				MM_BETA = createGroup civilian;
			};
		};
	};	
	
	[MM_PILOT1, MM_MEDIC] join MM_BETA;

	MM_BETA setBehaviour "CARELESS";
	
	nul = MM_MEDIC execVM "mount.sqf";

	waitUntil{MM_MEDIC in (crew MM_CHOPPER) || !(alive MM_MEDIC)}; //wait MM_MEDIC to get in the mh60s or  his death
	[MM_GUNNR1, MM_GUNNR2] join MM_BETA; //rejoin pilots and units to group MM_BETA
	
	MM_BETA setBehaviour "CARELESS";
	
	nul = MM_GUNNR1 execVM "mount.sqf";
	
	sleep 1;
	
	nul = MM_GUNNR2 execVM "mount.sqf";

	waitUntil{MM_GUNNR1 in (crew MM_CHOPPER) || !(alive MM_GUNNR1)};
	waitUntil{MM_GUNNR2 in (crew MM_CHOPPER) || !(alive MM_GUNNR2)};
	
	deletevehicle MM_HELIH2;
	deleteVehicle MM_SMOKE;
	
	//MM_CHOPPER removeAction MM_ABOR;
	
	//MM_CHOPPER flyInHeight 100;
	
	//--------------------------------------------------------------------------------------------------------------------------
	if(!MM_CISIAMO) then{ //objects destruction at the waypoint activation
		sleep 2;
		_wp4 = MM_BETA addWaypoint [getMarkerPos "MM_MKR1",0]; //add a waypoint at the pilot to return to base
		sleep 1;
		_wp4 setWaypointType "MOVE";
		_wp4 setWaypointSpeed "FULL";
		_wp4 setWaypointStatements ["true", "if (isServer) then {{deleteVehicle _x} forEach (crew MM_CHOPPER); deleteVehicle MM_CHOPPER;  MM_AVVIONE_2 = 1; MM_WEARE = 0;}"];
	}
	else{
		MM_HELIH2 = createVehicle ["HeliHEmpty", getMarkerPos "MM_MKR1", [], 0, "NONE"];	
		MM_CREWS = crew MM_CHOPPER;
		MM_CREWS = MM_CREWS - [MM_MEDIC, MM_GUNNR1, MM_GUNNR2, MM_PILOT1, MM_PILOT2, MM_PILOT3];
		_wp4 = MM_BETA addWaypoint [getMarkerPos "MM_MKR1",0]; //add a waypoint at the pilot to return to base
		_wp4 setWaypointType "MOVE";
		_wp4 setWaypointSpeed "FULL";
		_wp4 setWaypointStatements ["true", "if (isServer) then {MM_CHOPPER land 'LAND'; MM_AVVIONE_2 = 1; MM_CHECKER = [] execVM 'checker.sqf'}"]; //set the helo to LAND at the base
	};	
	//---------------------------------------------------------------------------------------------------------------------------
	
	waitUntil{MM_AVVIONE_2 == 1};

	//if finded extra units inside the Medevac vehicle
	if((count MM_CREWS) > 0 && !(MM_PLAYER in MM_CREWS)) then{
		waitUntil{(getPosATL MM_CHOPPER) select 2 <0.5};
		{_x action ["GetOut", vehicle _x]; unassignVehicle _x} forEach MM_CREWS;
		{ if(!(isPlayer _x)) then{[_x] join MM_DELTA} } forEach MM_CREWS;
		_wp5 = MM_DELTA addWaypoint [getMarkerPos "MM_MKR1", 0]; //add a waypoint at the pilot to return to base
		_wp5 setWaypointType "MOVE";
		_wp5 setWaypointSpeed "FULL";
	};
	
	//MM_CHOPPER removeAction MM_REINSERT;
	if (MM_RAZIONE == 1) then{
		MM_RAZIONE = 0;
	}
	else{
		MM_RAZIONE = 1;
	};
	publicVariable "MM_RAZIONE";
	
	// add the reinsert action at MM_CHOPPER
	MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "dummy2.sqf"];
	if (MM_ARAZIONE == 1) then{
		MM_ARAZIONE = 0;
	}
	else{
		MM_ARAZIONE = 1;
	};
	publicVariable "MM_ARAZIONE";
	
	sleep 50;
	hint "Medevac support available";
	MM_DUMMYA = MM_PLAYER addAction ["", ""];
	MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "dummy.sqf"];
	sleep 1;
	MM_PLAYER removeAction MM_DUMMYA;
	
	MM_AVVIONE = 1;
	publicVariable "MM_AVVIONE";
	
	//add action to caller
	if(MM_ADD == 0) then{
		MM_ADD = 1;
	}	
	else{
		MM_ADD = 0;
	};	
	publicVariable "MM_ADD";
}
else {
    hint "Medevac support already active";
};   



