// include the unit's arrays
#include "unit_array.hpp";

onMapSingleClick "";

// global variable initialization
MM_AVVIONE = 1;
MM_AZZIONE = 0;
MM_CISIAMO = false;
MM_WEARE = 0;
MM_READY = 1;
MM_COUNTER = 0;
MM_HIGHER = 0;
MM_RACTIVE = 0;
MM_CLIENT = 0;
MM_ABORTO = 0;
MM_REMOVE = 0;
MM_ADD = 0;
MM_SALVA = 0;
MM_BASE = 0;
MM_EXPL = 0;
MM_POSRESC = 0;
MM_ORA = 0;
MM_REINSERIMENTO = 0;
MM_RESCUEMISSION = 0;
MM_FRE = 0;
MM_RAZIONE = 0;
MM_RAZIONE2 = 0;
MM_ARAZIONE = 0;
MM_TRES = 0;
MM_ADDRTB = 0;
MM_RTBOK = 0;

MM_ONE = 0;
MM_TWO = 0;
MM_THREE = 0;
MM_FOUR = 0;
MM_FIVE = 0;
MM_SIX = 0;
MM_SEVEN = 0;
MM_EIGHT = 0;
MM_NINE = 0;
MM_TEN = 0;
MM_ELEVEN = 0;
MM_TWELVE = 0;
MM_THIRTEEN = 0;
MM_FOURTEEN = 0;
MM_FIFTEEN = 0;
MM_SIXTEEN = 0;
MM_SEVENTEEN = 0;
MM_EIGHTEEN = 0;
MM_NINETEEN = 0;
MM_TWENTY = 0;
MM_TWENTYONE = 0;
MM_TWENTYTWO = 0;
MM_TWENTYTHREE = 0;


PAPABEAR = [West,"HQ"];

// player and base camp initialization
if (isNil "MM_CALLER") then{
	hint "ERROR: you have to initialize the MM_CALLER array in the init field of the Game Logic";
}
else{
	{
		if(_x isKindOf "Logic") then{ // finded the game logic
			MM_CISIAMO = true;        // finded a base camp	
			MM_BSCM = position _x;    // get its position
		}
		else{ 
			if(_x == player) then{
				MM_PLAYER = _x;
				MM_DEAD = MM_PLAYER addEventHandler ["killed", "_nul = [] execVM 'dead.sqf'"];
			};	
		};
	} forEach MM_CALLER;
};

"MM_RAZIONE" addPublicVariableEventHandler {MM_CHOPPER removeAction MM_REINSERT};
	
//********************************************************************
//********************************************************************	
//******************** code executed by server ***********************
//********************************************************************
//********************************************************************

if (isServer) then{
	"MM_CLIENT" addPublicVariableEventHandler {_nul = execVM "dummy.sqf"};
	"MM_ABORTO" addPublicVariableEventHandler {_nul = execVM "dummy3.sqf"};
	"MM_REINSERIMENTO" addPublicVariableEventHandler {_nul = execVM "dummy2.sqf"};
	"MM_ARAZIONE" addPublicVariableEventHandler{MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "dummy2.sqf"]};
	"MM_TRES" addPublicVariableEventHandler{_nul = execVM "dummy4.sqf"};
	
	if (!MM_CISIAMO) then{ 
		//create MM_MKR1 at the default position [100,100,0]
		_mkr = createMarker ["MM_MKR1", [100, 100, 0]];
		"MM_MKR1" setMarkerType "Flag";
		"MM_MKR1" setMarkerColor "ColorGreen";
		"MM_MKR1" setMarkerText "Medevac arrival position";
	}
	else{ 
		//create the marker in the camp
		_mkr = createMarker ["MM_MKR1", MM_BSCM];
		"MM_MKR1" setMarkerType "Flag";
		"MM_MKR1" setMarkerColor "ColorGreen";
		"MM_MKR1" setMarkerText "Medevac position";
		_create = [] execVM "unitCreation.sqf"; 
	};
	
	MM_DUMMYA = MM_PLAYER addAction ["",""];
	MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "dummy.sqf"];
	
};


//********************************************************************
//********************************************************************	
//*************** code executed by the connected players *************
//********************************************************************
//********************************************************************

if (!isServer) then{

	if (player != player) then
	{
		waitUntil {player == player};
		waitUntil {time > 10};
	};	
	
	"MM_ADDRTB" addPublicVariableEventHandler {MM_RTB = MM_PLAYER addAction ["Medevac RTB", "dummy7.sqf"]; MM_RTBOK = 1 };
	"MM_RAZIONE2" addPublicVariableEventHandler {if (MM_PLAYER == player) then{ MM_CHOPPER removeAction MM_ABOR; }};
	"MM_ARAZIONE" addPublicVariableEventHandler {MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "client2.sqf"]};
	"MM_REMOVE" addPublicVariableEventHandler {MM_PLAYER removeAction MM_AACTION; MM_AZZIONE = 0};
	"MM_ADD" addPublicVariableEventHandler {MM_DUMMYA = MM_PLAYER addAction ["",""]; MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "client.sqf"]; MM_PLAYER removeAction MM_DUMMYA; hint "Medevac support available"};
	"MM_SALVA" addPublicVariableEventHandler {_nul = [] execVM "rescue_client.sqf"};
	"MM_RESCUEMISSION" addPublicVariableEventHandler {MM_DUMMYA = MM_PLAYER addAction ["",""]; MM_RACTION = MM_PLAYER addAction ["Call for rescue", "rescue_m.sqf"]; MM_RACTIVE = 1; MM_PLAYER removeAction MM_DUMMYA;};

	MM_DUMMYA = MM_PLAYER addAction ["",""];
	MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "client.sqf",[],0]; //give at the player the 'Call in medevac' action

	MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "client2.sqf"];
};	

_nul = [] execVM "trigger.sqf";