//*********************************************************************************
// aborted.sqf
// this script is activated only when the corpsman dead and make the helicopter
// to return to base and make correctly ending all previous MM_SCRIPts
//*********************************************************************************

if(alive MM_CHOPPER && MM_AVVIONE == 0 && getDammage MM_CHOPPER < 0.6 && isEngineOn MM_CHOPPER) then{       
	
	//terminate current launched MM_SCRIPts
	terminate MM_HEALER;
	terminate MM_LES;
	
	//delete the invisible H
	deleteVehicle MM_HELIH2;
	
	//remove the 'fired' eventHandler from the player
	if(MM_COUNTER == 1) then{
		MM_PLAYER removeMagazine "SmokeShellRed";
		MM_PLAYER removeEventHandler ["Fired", MM_EH1];
		MM_COUNTER = 0;
	};	
	
	//remove the 'Abort Action' from the player
	MM_PLAYER removeAction MM_AACTION;
	MM_AZZIONE = 0;

	//MM_PILOT1 sideChat "Roger that. Medevac mission aborted. Return to Base";
	MM_ELEVEN = 1;
	publicVariable "MM_ELEVEN";
	
	//delete the Radio Bravo trigger
	//deleteVehicle MM_TRGGG1;

	//delete the 'old' MM_BETA group to create a new one
	deleteGroup MM_BETA;
	
	//recreate the MM_BETA group
	if(side MM_PLAYER == west) then{
		MM_BETA = createGroup west;
	}
	else{
		if(side MM_PLAYER == east) then{
			MM_BETA = createGroup east;
		}	
		else{
			if(side MM_PLAYER == resistance) then{
				MM_BETA = creategroup resistance;
			}
			else{
				MM_BETA = createGroup civilian;
			};
		};
	};	
	
	//make units join the MM_BETA group
	[MM_PILOT1, MM_MEDIC] join MM_BETA;

	//make the MM_BETA's units to be CARELESS
	MM_BETA setBehaviour "CARELESS";
	
	//exec the mount MM_SCRIPt to permit the unit to mount the chopper
	_nul = MM_MEDIC execVM "mount.sqf";
    
	//wait MM_MEDIC to get in the mh60s
	waitUntil{MM_MEDIC in (crew MM_CHOPPER) || !(alive MM_MEDIC)};
	
	//rejoin gunners to group MM_BETA
	[MM_GUNNR1, MM_GUNNR2] join MM_BETA; 
	
	//make the MM_BETA's units to be CARELESS
	MM_BETA setBehaviour "CARELESS";
	
	//exec the mount MM_SCRIPt to permit the unit to mount the chopper
	_nul = MM_GUNNR1 execVM "mount.sqf";
	
	sleep 1;
	
	//exec the mount MM_SCRIPt to permit the unit to mount the chopper
	_nul = MM_GUNNR2 execVM "mount.sqf";
	
	//wait for gunners to mount the chopper
	waitUntil{MM_GUNNR2 in (crew MM_CHOPPER) || !(alive MM_GUNNR2)};
	waitUntil{MM_GUNNR1 in (crew MM_CHOPPER) || !(alive MM_GUNNR1)};

	//--------------------------------------------------------------------------------------------------------------------------
	if(!MM_CISIAMO) then{ 
		//objects destruction at the waypoint activation
		_wpret = MM_BETA addWaypoint [getMarkerPos "MM_MKR1",0]; 
		_wpret setWaypointType "MOVE";
		_wpret setWaypointSpeed "FULL";
		_wpret setWaypointStatements ["true", "{deleteVehicle _x} forEach (crew MM_CHOPPER); deleteVehicle MM_CHOPPER; MM_AVVIONE = 1; publicVariable 'MM_AVVIONE'; MM_WEARE = 0;"];
	}
	else{
		//return the chopper to the FOB anc check for all its crews
		MM_HELIH2 = createVehicle ["HeliHEmpty", getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_CREWS = crew MM_CHOPPER; //check for all MM_CHOPPER's crews
		MM_CREWS = MM_CREWS - [MM_MEDIC, MM_GUNNR1, MM_GUNNR2, MM_PILOT1, MM_PILOT2, MM_PILOT3]; //delete from the variable the already known crews
		_wpret = MM_BETA addWaypoint [getMarkerPos "MM_MKR1",0];
		_wpret setWaypointType "MOVE";
		_wpret setWaypointSpeed "FULL";
		_wpret setWaypointStatements ["true", "MM_CHOPPER land 'LAND'; MM_AVVIONE = 1; publicVariable 'MM_AVVIONE'; MM_CHECKER = [] execVM 'checker.sqf'"]; 
	};	
	//---------------------------------------------------------------------------------------------------------------------------

	//wait for the chopper to return to FOB
	waitUntil{MM_AVVIONE == 1};
	
	if((count MM_CREWS) > 0) then{
		waitUntil{(getPosATL MM_CHOPPER) select 2 <0.5};

		{_x action ["GetOut", vehicle _x]; unassignVehicle _x} forEach MM_CREWS;
		{ if(!(isPlayer _x)) then{[_x] join MM_DELTA} } forEach MM_CREWS;

		_wp5 = MM_DELTA addWaypoint [getMarkerPos "MM_MKR1", 0]; //add a waypoint at the pilot to return to base
		_wp5 setWaypointType "MOVE";
		_wp5 setWaypointSpeed "FULL";
	};

	sleep 50;
	
	//add action to caller
	if(MM_ADD == 0) then{
		MM_ADD = 1;
		publicVariable "MM_ADD";
	}	
	else{
		MM_ADD = 0;
		publicVariable "MM_ADD";
	};
	
	hint "Medevac support available";
	MM_DUMMYA = MM_PLAYER addAction ["",""];
	MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "dummy.sqf"];
	sleep 1;
	MM_PLAYER removeAction MM_DUMMYA;
};





	