// rescue_m.sqf
// this script simulate the Extraction mission for the downed MM_CHOPPER
// - execute only on client side -

MM_ROGER =  createGroup west;
MM_RACTIVE = 0;
MM_ONBOARD = 0;
MM_PLAYER removeAction MM_RACTION;

_coord = mapGridPosition MM_PLAYER;

MM_PLAYER sideChat format["CROSSROAD we have found the medevac's units. Extraction needed at coord %1, over", _coord];
sleep 3;
MM_PLAYER sideChat format["Roger. Rescue chopper sent at location %1", _coord];

if(side MM_PLAYER == west) then{
		//creating western groups
		MM_ROGER = createGroup west;

		//spawn chopper
		MM_RESCUE = createVehicle [(MM_WEST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
		MM_RESCUE addEventHandler ["killed", "hint 'Rescue chopper is blowed up'"];

		//spawn pilot
		MM_P1 = MM_ROGER createUnit [(MM_WEST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P1 assignAsDriver MM_RESCUE;
		MM_P1 moveInDriver MM_RESCUE;

		//spawn left gunner
		MM_P2 = MM_ROGER createUnit [(MM_WEST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P2 moveInTurret [MM_RESCUE,[0]];

		//spawn right gunner
		MM_P3 = MM_ROGER createUnit [(MM_WEST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P3 moveInTurret [MM_RESCUE,[1]]; 
}
else{
	if(side MM_PLAYER == east) then{
		//creating western groups
		MM_ROGER = createGroup east;

		//spawn chopper
		MM_RESCUE = createVehicle [(MM_EAST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
		MM_RESCUE addEventHandler ["killed", "hint 'Rescue chopper is blowed up'"];

		//spawn pilot
		MM_P1 = MM_ROGER createUnit [(MM_EAST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P1 assignAsDriver MM_RESCUE;
		MM_P1 moveInDriver MM_RESCUE;

		//spawn left gunner
		MM_P2 = MM_ROGER createUnit [(MM_EAST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P2 moveInTurret [MM_RESCUE,[0]];

		//spawn right gunner
		MM_P3 = MM_ROGER createUnit [(MM_EAST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_P3 moveInTurret [MM_RESCUE,[1]]; 
	}
	else{
		if(side MM_PLAYER == resistance) then{
			//creating western groups
			MM_ROGER = createGroup resistance;

			//spawn chopper
			MM_RESCUE = createVehicle [(MM_RES_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
			MM_RESCUE addEventHandler ["killed", "hint 'Rescue chopper is blowed up'"];

			//spawn pilot
			MM_P1 = MM_ROGER createUnit [(MM_RES_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P1 assignAsDriver MM_RESCUE;
			MM_P1 moveInDriver MM_RESCUE;

			//spawn left gunner
			MM_P2 = MM_ROGER createUnit [(MM_RES_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P2 moveInTurret [MM_RESCUE,[0]];

			//spawn right gunner
			MM_P3 = MM_ROGER createUnit [(MM_RES_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P3 moveInTurret [MM_RESCUE,[1]]; 
	
		}
		else{ 
			//creating western groups
			MM_ROGER = createGroup civilian;

			//spawn chopper
			MM_RESCUE = createVehicle [(MM_CIV_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
			MM_RESCUE addEventHandler ["killed", "hint 'Rescue chopper is blowed up'"];

			//spawn pilot
			MM_P1 = MM_ROGER createUnit [(MM_CIV_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P1 assignAsDriver MM_RESCUE;
			MM_P1 moveInDriver MM_RESCUE;

			//spawn left gunner
			MM_P2 = MM_ROGER createUnit [(MM_CIV_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P2 moveInTurret [MM_RESCUE,[0]];

			//spawn right gunner
			MM_P3 = MM_ROGER createUnit [(MM_CIV_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_P3 moveInTurret [MM_RESCUE,[1]]; 
		};
	};
};

MM_ROGER setBehaviour "SAFE";
MM_BETA setBehaviour "CARELESS";

_wp1 = MM_ROGER addWaypoint [position MM_PLAYER, 0]; //add a waypoint at the pilot to return to base
_wp1 setWaypointType "MOVE";
_wp1 setWaypointStatements ["true", "MM_RESCUE land 'GET IN'"]; 

waitUntil{MM_RESCUE in ((getPos MM_PLAYER) nearObjects ["Helicopter", 200])};

MM_PLAYER sideChat "Rescue chopper in position sir";

//MM_RTRG = createTrigger["EmptyDetector", [0,0,0]]; //create a radio trigger to abort the medevac mission
//MM_RTRG setTriggerArea[5,5,0,false];
//MM_RTRG setTriggerActivation["DELTA","PRESENT",false];
//MM_RTRG setTriggerStatements["this", "MM_ONBOARD = 1; MM_PILOT1 sideChat 'Chopper returning to base, out'", ""];
//MM_RTRG setTriggerText "Extraction RTB";

MM_DUMMYA = MM_PLAYER addAction ["",""];
MM_EACTION = MM_PLAYER addAction ["Extraction RTB", "dummy5.sqf"];
sleep 1;
MM_PLAYER removeAction MM_DUMMYA;


while{MM_ONBOARD == 0} do{
	sleep 1;
};	

_wp2 = MM_ROGER addWaypoint [getMarkerPos "MM_MKR1",0]; //add a waypoint at the pilot to return to base
_wp2 setWaypointType "MOVE";
_wp2 setWaypointSpeed "FULL";
_wp2 setWaypointStatements ["true", "{deleteVehicle _x} forEach (crew MM_RESCUE); deleteVehicle MM_RESCUE"]; 
