//*********************************************************************************
// resort.sqf
// this script check if the medevac's pilot and medic are still alive and recreate
// them if not
//*********************************************************************************


if ((getDammage MM_CHOPPER) > 0.5) then{
		//PAPABEAR sideChat "Medevac chopper damaged. Medevac not available";
		MM_TEN = 1;
		publicVariable "MM_TEN";
		MM_DAMMAGED = [] execVM "dammaged.sqf";
}
else{

if (alive MM_CHOPPER) then{

	MM_CHOPPER setFuel 1;
	MM_CHOPPER setDammage 0;

	if(side MM_PLAYER == west) then{
		
		if (!alive MM_PILOT1) then {
			MM_PILOT1 = MM_BETA createUnit [(MM_WEST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
		};
		
		MM_PILOT1 assignAsDriver MM_CHOPPER;
		MM_PILOT1 moveInDriver MM_CHOPPER;  
		MM_PILOT1 disableAI "TARGET";
		MM_PILOT1 disableAI "AUTOTARGET";
		
		_nullvar = [] execVM "checkkin.sqf"; //check to see if the medic is dead

		MM_MEDIC moveInCargo MM_CHOPPER;
		MM_MEDIC assignAsCargo MM_CHOPPER;

	    MM_PILOT2 moveInTurret [MM_CHOPPER,[0]];
		MM_PILOT3 moveInTurret [MM_CHOPPER,[1]];
		
		MM_GUNNR1 assignAsCargo MM_CHOPPER;
		MM_GUNNR1 moveInCargo MM_CHOPPER;
		
		MM_GUNNR2 assignAsCargo MM_CHOPPER;
		MM_GUNNR2 moveInCargo MM_CHOPPER;

	}
	else{
		if(side MM_PLAYER == east) then{

			_nullvar = [] execVM "checkkin.sqf"; //check to see if the medic is dead
			
			MM_MEDIC assignAsCargo MM_CHOPPER;
			MM_MEDIC moveInCargo MM_CHOPPER;
			
			
			if (!alive MM_PILOT1) then {
				MM_PILOT1 = MM_BETA createUnit [(MM_EAST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
				MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
			};
			
			MM_PILOT1 assignAsDriver MM_CHOPPER;
			MM_PILOT1 moveInDriver MM_CHOPPER; 
			MM_PILOT1 disableAI "TARGET";
		    MM_PILOT1 disableAI "AUTOTARGET";
			
			MM_GUNNR1 assignAsCargo MM_CHOPPER;
			MM_GUNNR1 moveInCargo MM_CHOPPER;
			
			MM_GUNNR2 assignAsCargo MM_CHOPPER;
			MM_GUNNR2 moveInCargo MM_CHOPPER;

		}	
		else{
			if(side MM_PLAYER == resistance) then{

				_nullvar = [] execVM "checkkin.sqf"; //check to see if the medic is dead
				
				MM_MEDIC assignAsCargo MM_CHOPPER;
				MM_MEDIC moveInCargo MM_CHOPPER;
				
				
				if (!alive MM_PILOT1) then {
					MM_PILOT1 = MM_BETA createUnit [(MM_RES_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
					MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
				};
			
				MM_PILOT1 assignAsDriver MM_CHOPPER;
				MM_PILOT1 moveInDriver MM_CHOPPER; 
				MM_PILOT1 disableAI "TARGET";
				MM_PILOT1 disableAI "AUTOTARGET";
				
				MM_GUNNR1 assignAsCargo MM_CHOPPER;
				MM_GUNNR1 moveInCargo MM_CHOPPER;
				
				MM_GUNNR2 assignAsCargo MM_CHOPPER;
				MM_GUNNR2 moveInCargo MM_CHOPPER;

			}
			else{

				_nullvar = [] execVM "checkkin.sqf"; //check to see if the medic is dead
				
				MM_MEDIC assignAsCargo MM_CHOPPER;
				MM_MEDIC moveInCargo MM_CHOPPER;
				
				if (!alive MM_PILOT1) then{
					MM_PILOT1 = MM_BETA createUnit [(MM_CIV_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
					MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
				};
				
				MM_PILOT1 assignAsDriver MM_CHOPPER;
				MM_PILOT1 moveInDriver MM_CHOPPER; 
				MM_PILOT1 disableAI "TARGET";
				MM_PILOT1 disableAI "AUTOTARGET";
				
				MM_GUNNR1 assignAsCargo MM_CHOPPER;
				MM_GUNNR1 moveInCargo MM_CHOPPER;
				
				MM_GUNNR2 assignAsCargo MM_CHOPPER;
				MM_GUNNR2 moveInCargo MM_CHOPPER;
			};
		};
	};
		
		// if self-hosted or SP
		hint "Medevac support available";
		MM_DUMMYA = MM_PLAYER addAction ["",""];
		MM_ACTION0 = MM_PLAYER addAction ["Call in Medevac", "dummy.sqf"]; //give at the player the 'Call in medevac' action
		sleep 1;
		MM_PLAYER removeAction MM_DUMMYA;
		
		// add action to caller if client or dedi server
		if(MM_ADD == 0) then{
			MM_ADD = 1;
			publicVariable "MM_ADD";
		}	
		else{
			MM_ADD = 0;
			publicVariable "MM_ADD";
		};
		
		MM_LAND = [] execVM "landing.sqf";
};
};

	