//*********************************************************************************
//unitCreation.sqf
//this script create all the unit that are necessary for the Medevac operation
//by goliath86
//*********************************************************************************

if(side (MM_CALLER select 0) == west) then{
		//creating western groups
		MM_BETA = createGroup west;
		MM_ALPHA = createGroup west;
		MM_CHARLIE = createGroup west;
		MM_DELTA = createGroup west;
		MM_PILOTS = createGroup west;
		
		//spawn chopper
		if(!MM_CISIAMO) then{
			MM_CHOPPER = createVehicle [(MM_WEST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"]; 
			MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
		}
		else{
			MM_CHOPPER = createVehicle [(MM_WEST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "NONE"];
			MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then { MM_SCRIP = _this execVM 'rescue.sqf' }"];
		};
		MM_CHOPPER addEventHandler ["killed", "terminate MM_SCRIP; hint 'Medevac is blowed up'; terminate MM_DIS; terminate MM_HEALER; terminate MM_RESORT; terminate MM_ABORTITO; terminate MM_REINSERTING; terminate MM_DAMMAGED; MM_PLAYER removeAction MM_ACTION0; MM_PLAYER removeAction MM_AACTION; MM_CHOPPER removeAction MM_REINSERT; MM_CHOPPER removeAction MM_ABOR; terminate MM_ABORESC; deleteVehicle MM_TRGGG1"];

		//spawn medic
		MM_MEDIC = MM_BETA createUnit [(MM_WEST_ARRAY) select 1, getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_MEDIC moveInCargo MM_CHOPPER;
		MM_MEDIC assignAsCargo MM_CHOPPER;
		//MM_MEDIC addEventHandler ["killed", {_this execVM "aborted.sqf"}];
		//select the medic as leader of group MM_BETA
		MM_BETA selectLeader MM_MEDIC;

		//spawn gunner assistant 1
		MM_GUNNR1 = MM_BETA createUnit [(MM_WEST_ARRAY) select 5, getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_GUNNR1 moveInCargo MM_CHOPPER;
		MM_GUNNR1 assignAsCargo MM_CHOPPER;		
		MM_GUNNR1 addEventHandler ["killed", "deleteVehicle MM_GUNNR1"];
		
		//spawn gunner assistant 2
		MM_GUNNR2 = MM_BETA createUnit [(MM_WEST_ARRAY) select 6, getMarkerPos "MM_MKR1", [], 0, "NONE"];		
		MM_GUNNR2 moveInCargo MM_CHOPPER;
		MM_GUNNR2 assignAsCargo MM_CHOPPER;
		MM_GUNNR2 addEventHandler ["killed", "deleteVehicle MM_GUNNR2"];
		
		//spawn pilot
		MM_PILOT1 = MM_BETA createUnit [(MM_WEST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_PILOT1 assignAsDriver MM_CHOPPER;
		MM_PILOT1 moveInDriver MM_CHOPPER;
		MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
		
		//spawn left gunner
		MM_PILOT2 = MM_PILOTS createUnit [(MM_WEST_ARRAY) select 3, getMarkerPos "MM_MKR1", [], 0, "NONE"];	
		MM_PILOT2 moveInTurret [MM_CHOPPER,[0]];

		//spawn right gunner
		MM_PILOT3 = MM_PILOTS createUnit [(MM_WEST_ARRAY) select 4, getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_PILOT3 moveInTurret [MM_CHOPPER,[1]]; 

		
		//flag of unit created
		MM_WEARE = 1;
	
}
else{
	if(side (MM_CALLER select 0) == east) then{
		//creating eastern groups
		MM_BETA = createGroup east;
		MM_ALPHA = createGroup east;
		MM_CHARLIE = createGroup east;
		MM_DELTA = createGroup east;
		MM_PILOTS = createGroup east;
		
		//spawn chopper
		if(!MM_CISIAMO) then{
			MM_CHOPPER = createVehicle [(MM_EAST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
			MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
		}
		else{
			MM_CHOPPER = createVehicle [(MM_EAST_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "NONE"];  
			MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
		};
		MM_CHOPPER addEventHandler ["killed", "terminate MM_SCRIP; hint 'Medevac is blowed up'; terminate MM_DIS; terminate MM_HEALER; terminate MM_RESORT; terminate MM_ABORTITO; terminate MM_REINSERTING; terminate MM_DAMMAGED; MM_PLAYER removeAction MM_ACTION0; MM_PLAYER removeAction MM_AACTION; MM_CHOPPER removeAction MM_REINSERT; MM_CHOPPER removeAction MM_ABOR; terminate MM_ABORESC; deleteVehicle MM_TRGGG1"];
		
		//spawn medic
		MM_MEDIC = MM_BETA createUnit [(MM_EAST_ARRAY) select 1, getMarkerPos "MM_MKR1", [], 0, "NONE"];
		MM_MEDIC moveInCargo MM_CHOPPER;
		MM_MEDIC assignAsCargo MM_CHOPPER;		
		//MM_MEDIC addEventHandler ["killed", {_this execVM "aborted.sqf"}];

		//spawn gunner assistant 1
		MM_GUNNR1 = MM_BETA createUnit [(MM_EAST_ARRAY) select 5, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_GUNNR1 moveInCargo MM_CHOPPER;
		MM_GUNNR1 assignAsCargo MM_CHOPPER;
		MM_GUNNR1 addEventHandler ["killed", "deleteVehicle MM_GUNNR1"];
		
		//spawn gunner assistant 2
		MM_GUNNR2 = MM_BETA createUnit [(MM_EAST_ARRAY) select 6, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_GUNNR2 moveInCargo MM_CHOPPER;
		MM_GUNNR2 assignAsCargo MM_CHOPPER;
		MM_GUNNR2 addEventHandler ["killed", "deleteVehicle MM_GUNNR2"];
		
		//spawn pilot
		MM_PILOT1 = MM_BETA createUnit [(MM_EAST_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_PILOT1 assignAsDriver MM_CHOPPER;
		MM_PILOT1 moveInDriver MM_CHOPPER; 
		MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
		
		//spawn left gunner
		MM_PILOT2 = MM_PILOTS createUnit [(MM_EAST_ARRAY) select 3, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_PILOT2 moveInTurret [MM_CHOPPER,[0]];

		//spawn right gunner
		MM_PILOT3 = MM_PILOTS createUnit [(MM_EAST_ARRAY) select 4, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
		MM_PILOT3 moveInTurret [MM_CHOPPER,[1]]; 
		
		//flag of unit created
		MM_WEARE = 1;
	}
	else{
		if(side (MM_CALLER select 0) == resistance) then{
			//creating resistance groups
			MM_BETA = createGroup resistance;
			MM_ALPHA = createGroup resistance;
			MM_CHARLIE = createGroup resistance;
			MM_DELTA = createGroup resistance;
			MM_PILOTS = createGroup resistance;
			
			//spawn chopper
			if(!MM_CISIAMO) then{
				MM_CHOPPER = createVehicle [(MM_RES_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];
				MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
			}
			else{
				MM_CHOPPER = createVehicle [(MM_RES_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "NONE"];
				_name = "MM_HELL";
				MM_CHOPPER setVehicleVarName _name;
				MM_CHOPPER call compile format["%1=_This ; PublicVariable ""%1""", _name];
				MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
			};
			MM_CHOPPER addEventHandler ["killed", "terminate MM_SCRIP; hint 'Medevac is blowed up'; terminate MM_DIS; terminate MM_HEALER; terminate MM_RESORT; terminate MM_ABORTITO; terminate MM_REINSERTING; terminate MM_DAMMAGED; MM_PLAYER removeAction MM_ACTION0; MM_PLAYER removeAction MM_AACTION; MM_CHOPPER removeAction MM_REINSERT; MM_CHOPPER removeAction MM_ABOR; terminate MM_ABORESC; deleteVehicle MM_TRGGG1"];
		
			//spawn medic
			MM_MEDIC = MM_BETA createUnit [(MM_RES_ARRAY) select 1, getMarkerPos "MM_MKR1", [], 0, "NONE"];
			MM_MEDIC moveInCargo MM_CHOPPER;
			MM_MEDIC assignAsCargo MM_CHOPPER;
			//MM_MEDIC addEventHandler ["killed", {_this execVM "aborted.sqf"}];

			//spawn gunner assistant 1
			MM_GUNNR1 = MM_BETA createUnit [(MM_RES_ARRAY) select 5, getMarkerPos "MM_MKR1", [], 0, "NONE"];
			MM_GUNNR1 moveInCargo MM_CHOPPER;
			MM_GUNNR1 assignAsCargo MM_CHOPPER;
			MM_GUNNR1 addEventHandler ["killed", "deleteVehicle MM_GUNNR1"];
			
			//spawn gunner assistant 2
			MM_GUNNR2 = MM_BETA createUnit [(MM_RES_ARRAY) select 6, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_GUNNR2 moveInCargo MM_CHOPPER;
			MM_GUNNR2 assignAsCargo MM_CHOPPER;
			MM_GUNNR2 addEventHandler ["killed", "deleteVehicle MM_GUNNR2"];
			
			//spawn pilot
			MM_PILOT1 = MM_BETA createUnit [(MM_RES_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"];
			MM_PILOT1 assignAsDriver MM_CHOPPER;
			MM_PILOT1 moveInDriver MM_CHOPPER;
			MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
			
			//spawn left gunner
			MM_PILOT2 = MM_PILOTS createUnit [(MM_RES_ARRAY) select 3, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT2 moveInTurret [MM_CHOPPER,[0]];

			//spawn right gunner
			MM_PILOT3 = MM_PILOTS createUnit [(MM_RES_ARRAY) select 4, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT3 moveInTurret [MM_CHOPPER,[1]]; 
			
			
			//flag of unit created
			MM_WEARE = 1; 
		}
		else{ 
			//creating civilian groups
			MM_BETA = createGroup civilian;
			MM_ALPHA = createGroup civilian;
			MM_CHARLIE = createGroup civilian;
			MM_DELTA = createGroup civilian;
			MM_PILOTS = createGroup civilian;

			//spawn chopper
			if(!MM_CISIAMO) then{
				MM_CHOPPER = createVehicle [(MM_CIV_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "FLY"];  
				MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
			}
			else{
				MM_CHOPPER = createVehicle [(MM_CIV_ARRAY) select 0, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
				MM_CHOPPER addEventHandler ["Engine", "if(!(_this select 1)) then{MM_SCRIP = _this execVM 'rescue.sqf'}"];
			};
			MM_CHOPPER addEventHandler ["killed", "terminate MM_SCRIP; hint 'Medevac is blowed up'; terminate MM_HEALER; terminate MM_DIS; terminate MM_RESORT; terminate MM_ABORTITO; terminate MM_REINSERTING; terminate MM_DAMMAGED; MM_PLAYER removeAction MM_ACTION0; MM_PLAYER removeAction MM_AACTION; MM_CHOPPER removeAction MM_REINSERT; MM_CHOPPER removeAction MM_ABOR; terminate MM_ABORESC; deleteVehicle MM_TRGGG1"];
		
			//spawn medic
			MM_MEDIC = MM_BETA createUnit [(MM_CIV_ARRAY) select 1, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_MEDIC moveInCargo MM_CHOPPER;
			MM_MEDIC assignAsCargo MM_CHOPPER;
			//MM_MEDIC addEventHandler ["killed", {_this execVM "aborted.sqf"}];

			//spawn gunner assistant 1
			MM_GUNNR1 = MM_BETA createUnit [(MM_CIV_ARRAY) select 5, getMarkerPos "MM_MKR1", [], 0, "NONE"];
			MM_GUNNR1 moveInCargo MM_CHOPPER;
			MM_GUNNR1 assignAsCargo MM_CHOPPER;			
			MM_GUNNR1 addEventHandler ["killed", "deleteVehicle MM_GUNNR1"];

			//spawn gunner assistant 2
			MM_GUNNR2 = MM_BETA createUnit [(MM_CIV_ARRAY) select 6, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_GUNNR2 moveInCargo MM_CHOPPER;
			MM_GUNNR2 assignAsCargo MM_CHOPPER;
			MM_GUNNR2 addEventHandler ["killed", "deleteVehicle MM_GUNNR2"];
			
			//spawn pilot
			MM_PILOT1 = MM_BETA createUnit [(MM_CIV_ARRAY) select 2, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT1 assignAsDriver MM_CHOPPER;
			MM_PILOT1 moveInDriver MM_CHOPPER;  
			MM_PILOT1 addEventHandler ["killed", "terminate MM_HEALER; MM_CHOPPER setFuel 0;"];
			
			
			//spawn left gunner
			MM_PILOT2 = MM_PILOTS createUnit [(MM_CIV_ARRAY) select 3, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT2 moveInTurret [MM_CHOPPER,[0]];

			//spawn right gunner
			MM_PILOT3 = MM_PILOTS createUnit [(MM_CIV_ARRAY) select 4, getMarkerPos "MM_MKR1", [], 0, "NONE"]; 
			MM_PILOT3 moveInTurret [MM_CHOPPER,[1]]; 
			
			//flag of unit created
			MM_WEARE = 1; 
		};
	};
};

//create an array _units wich contain all the crews of the MM_CHOPPER
_units = units MM_BETA;
_units = _units + units MM_PILOTS;

//delete all the units that don't find place in the Medevac vehicle
{
	if(!(_x in (crew MM_CHOPPER))) then{
		deleteVehicle _x;
	};
} forEach _units;	


// script for all the vehicle that are not an helicopter (like HMMWV, Trucks etc.)
if(!(MM_CHOPPER isKindOf "Helicopter") && MM_CISIAMO) then{  
	MM_CONTROLLO = MM_CHOPPER execVM "controlling.sqf";	
};	


//launch, only if present the Game Logic, the MM_SCRIPt that checks for the height of the chopper when waiting in base
if (MM_CISIAMO && (MM_CHOPPER isKindOf "Helicopter")) then{
	MM_CHECKER = MM_CHOPPER execVM "checker.sqf";
	MM_HELIH2 = createVehicle ["HeliHEmpty", getMarkerPos "MM_MKR1", [], 0, "NONE"];
};	

// public over the internet the MM_CHOPPER reference
_object = MM_CHOPPER;
_name = "MM_CHOPPER";
_object setVehicleVarName _name;
_object call compile format["%1 = _this; publicVariable ""%1""", _name];
publicVariable "MM_CHOPPER";

// add the Reinsert action to the chopper
MM_REINSERT = MM_CHOPPER addAction ["Reinsert", "reinsert.sqf"];

if (MM_ARAZIONE == 1) then{
	MM_ARAZIONE = 0;
}
else{
	MM_ARAZIONE = 1;
};
publicVariable "MM_ARAZIONE";	
	

MM_PILOT1 disableAI "TARGET";
MM_PILOT1 disableAI "AUTOTARGET";
MM_PILOTS setCombatMode "RED";
